unit unidadFormMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, Buttons, variants, shellapi;

type
  TformMenuPrincipal = class(TForm)
    LabelDatabase: TLabel;
    txtMDB: TEdit;
    lsUsuarios: TListView;
    bActualizar: TButton;
    RadioGroupOptions: TRadioGroup;
    bSelMDB: TSpeedButton;
    OpenDialog: TOpenDialog;
    LWEB: TLabel;
    bSalir: TButton;
    procedure bActualizarClick(Sender: TObject);
    procedure RadioGroupOptionsClick(Sender: TObject);
    procedure ButtonInfoClick(Sender: TObject);
    procedure bSelMDBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
    procedure bSalirClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

uses ActiveX;

{$R *.DFM}

function LDBUser_GetUsers(var UserBuffer: PSafeArray; DatabaseName: PChar; Options: Integer): Integer;
  stdcall; external 'MSLDBUSR.DLL';

function LDBUser_GetError(ErrorNo: Integer): PChar;
  stdcall; external 'MSLDBUSR.DLL';

procedure TformMenuPrincipal.RadioGroupOptionsClick(Sender: TObject);
begin
  bActualizarClick(Self);
end;

procedure TformMenuPrincipal.bActualizarClick(Sender: TObject);
var
  numUsuarios : Integer;
  UserBuffer : Variant;
  opcionSel : Integer;
  i : Integer;
begin
  lsUsuarios.Items.Clear;

  UserBuffer := VarArrayCreate([1, 1], varOleStr);

  case RadioGroupOptions.ItemIndex of
    0 : opcionSel := 1;
    1 : opcionSel := 2;
    2 : opcionSel := 4;
    3 : opcionSel := 8;
    else
      opcionSel := 1;
  end;
  numUsuarios := LDBUser_GetUsers(PSafeArray(TVarData(UserBuffer).VArray), PChar(txtMDB.Text), opcionSel);
  if numUsuarios < 0 then
    MessageDlg(LDBUser_GetError(numUsuarios), mtError, [mbOK], 0)
  else
  begin
    if opcionSel = 8 then
      MessageDlg ('N de usuarios conectados: ' + IntToStr(numUsuarios), mtInformation, [mbok], 0)
    else
    begin
      for i := 1 to numUsuarios do
      begin
        with lsUsuarios.Items.Add do
        begin
          Caption := IntToStr(i);
          SubItems.Add(PChar(TVarData(UserBuffer[i]).VPointer));
        end;
      end;
    end;
  end;
end;

procedure TformMenuPrincipal.ButtonInfoClick(Sender: TObject);
var
  UserBuffer: PSafeArray;
begin
  LDBUser_GetUsers(UserBuffer, '', $B0B);
end;

procedure TformMenuPrincipal.bSelMDBClick(Sender: TObject);
begin
  with OpenDialog do
  begin
    FileName := txtMDB.Text;
    if Execute then
    begin
      txtMDB.Text := FileName;
      bActualizarClick(Self);
    end;
  end;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
var
  i : integer;
  ruta : string;
begin
  if ParamCount > 0 then
  begin
    ruta := '';
    for i := 1 to ParamCount do
    begin
      if ruta = '' then
        ruta := ruta + ParamStr(i)
      else
        ruta := ruta + ' ' + ParamStr(i);
    end;
    txtMDB.Text := ruta;
    bActualizarClick(Self);
  end;
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.bSalirClick(Sender: TObject);
begin
  close;
end;

end.
